com.h3c.sdn.adm.config

## Interface ConfigService

- All Known Subinterfaces:
    ConfigServiceInternal

      public interface ConfigService

  Basic service supporting `Config` management.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Config` | `getConfig(String component)` Get the `Config` for the given component.
    `List<Config>` | `getConfigs()` Get `Config`s for all components.
    `Config` | `resetAll(String component, Authentication auth)` Reset all configuration items for the given component back to their defaults.
    `Config` | `resetConfigEntries(String component, List<String> keys, Authentication auth)` Reset to default the values for the specified keys of the given component.
    `Config` | `updateConfigEntries(String component, Map<String,String> pairs, Authentication auth)` Update the Config of a given component with the key/value `pairs` supplied.

- - ### Method Detail

    - #### getConfig

          Config getConfig(String component)

      Get the `Config` for the given component.
      Parameters:
        `component` - the name of the component whose Config will be retrieved.
      Returns:
        the Config of the component

    - #### getConfigs

          List<Config> getConfigs()

      Get `Config`s for all components.
      Returns:
        a List of Configs for all components

    - #### updateConfigEntries

          Config updateConfigEntries(String component,
                                   Map<String,String> pairs,
                                   Authentication auth)

      Update the Config of a given component with the key/value `pairs` supplied. The map of key/value pairs must be non-null and contain one or more entries with non-null keys that are valid keys for the given component.
      Parameters:
        `component` - the name of the component whose configuration will be updated
        `pairs` - a `Map` of key/value pairs to be updated
        `auth` - the authentication record for the user that invoked this method
      Returns:
        the full Config for the given component after it has been updated

    - #### resetConfigEntries

          Config resetConfigEntries(String component,
                                  List<String> keys,
                                  Authentication auth)

      Reset to default the values for the specified keys of the given component. This resets only the values for the keys that are specified.
      Parameters:
        `component` - the name of the component whose configurations will be reset
        `keys` - a list of valid keys whose values are to be reset to default
        `auth` - the authentication record for the user that invoked this method
      Returns:
        the full configuration for the component after the selective reset operation is complete

    - #### resetAll

          Config resetAll(String component,
                        Authentication auth)

      Reset all configuration items for the given component back to their defaults.
      Parameters:
        `component` - the name of the component whose configuration will be reset
        `auth` - the authentication record for the user that invoked this method
      Returns:
        the full configuration for the component after the full reset operation is complete

Copyright © 2014. All Rights Reserved.